#include "afw.h"
/** \file afw.cpp
 *  \brief I[fBIEt[[NEt@C
 *  \author AiOEfoCZY
 *
 * ̃t@CVisualDSP++ 4.5̃TvEAvP[VATalkTrhough
 * ĕύX̂łBEZ-KIT BF537̃I[fBIER[fBbN𗘗p
 * ߂̊֐QȂBB
 */
namespace afw{

    //--------------------------------------------------------------------------//
    // Symbolic constants														//
    //--------------------------------------------------------------------------//
    /** `lw萔
      *
      * afw::rxBufferсA afw::txBufferɃANZXہAŉʂ̓Yw
      * ƂɎgB
      *
      */
    const int LEFT_CH = 0;
    /** E`lw萔
      *
     * afw::rxBufferсA afw::txBufferɃANZXہAŉʂ̓Yw
      * ƂɎgB
      *
      */
    const int RIGHT_CH = 1;

    /** obt@錾萔
      *
      * DMAp̃obt@̈ afw::txBuffer afw::rxBufferƂ
      * mۂۂɁA荞݂̃obt@pӂ邩錾B
      * ̓Iɂ΁Agvobt@Ȃ̂3錾Bߋ3̊荞ݕ̃f[^obt@
      * i[łƂƂłB
      *
      */
    const int INTR_PER_BUFFER  = 3;	// ύXĂ͂ȂȂBgvobt@̂߂3̗̈m

    /** Tv`l̐錾
      *
      * Tv艽`l̃f[^`邩錾BI2S̓XeIȂ̂ŁA̒l2łB
      * ̒l̓[U[ύXĂ͂ȂȂB
      *
      */
    const int CH_PER_SAMPLE  = 2;	// ύXĂ͂ȂȂBI2S̓Tv2`l̃f[^

    /** 荞݂̃Tv
      *
      * Tṽf[^M犄荞݂邩w肷B̒l傫ق
      * 悭Ȃ邪Ax債A܂AKvȃʂBāA
      * oXlȂ烆[U[l߂邱ƂɂȂB
      */
    const int SAMPLE_PER_INTR = 8;	// ύX\BTvƂɊ荞݂邩w肷B

    /** I[fBIER[fbÑZbg
      *
      * EZ-KIT Lite BF537ł́AI[fBIER[fbÑZbgMADSP-BF537PF12
      * ڑĂBR[fbN̎gpɐ旧āA̐MAT[gȂ΂ȂȂB
      *
      * ̃}ŃAZbgMAT[g鎞Ԃ^BԂ̓[v̌JԂ
      * 񐔂Ȃ̂ŁA܂萸x͍ȂBӐ[lKvłB
      */
    const int CODEC_RESET_PULS_WIDTH  = 0x10000;

    /** SPORT0̃[h
      *
      * SPORT0ݒ莞Ɏg[hłBEZ-KIT BF537ɓڂĂR[fbN
      * 32bitI2SĝŁA[h32ɂȂ悤w肷B
      * 32bitɂꍇ́A31Ɛݒ肷邱ƂɒӁB
      */
    const int SPORT0_SLEN_32 = 31;


    //--------------------------------------------------------------------------//
    // ϐ     															//
    //--------------------------------------------------------------------------//

    /** SPORT0 DMA Mobt@
       * 
       * MDMAANZXASPORT TX`lɃf[^𑗂荞ނ߂̃obt@
       *
       * ŉʂ̎L, R`lp2̗vfi[B2Ԗڂ̎́A
       * 1񂲂ƂɑMTvw肷B1̊荞݂̊ԂDMA]
       * f[^̗ʂ́A afw::SAMPLE_PER_INTR * afw::CH_PER_SAMPLE Ō܂B
       *
       * ŏʂ̎́Ãobt@݉񕪂̃f[^
       * i[邩\B
       */
    volatile int txBuffer[INTR_PER_BUFFER][SAMPLE_PER_INTR][CH_PER_SAMPLE];
    /** SPORT0 DMA Mobt@
       * 
       * MDMAANZXASPORT RX`lf[^󂯎̃obt@
       *
       * ŉʂ̎L, R`lp2̗vfi[B2Ԗڂ̎́A
       * 1񂲂ƂɑMTvw肷B1̊荞݂̊ԂDMA]
         * f[^̗ʂ́A afw::SAMPLE_PER_INTR * afw::CH_PER_SAMPLE Ō܂B
       *
       * afw::INTR_PER_BUFFER pӂ鎟́Ãobt@݉񕪂̃f[^
       * i[邩\B
       */
    volatile int rxBuffer[INTR_PER_BUFFER][SAMPLE_PER_INTR][CH_PER_SAMPLE];

    /** GPIȌ
       * 
       * PORT FɊ蓖ĂĂGPIOitOsj̏sB
       * PORT F̃s蓖Ă͈ȉ̂ƂiJbR̓}XNj
       *  - pin 2..5  (0x003C) vbV{^
       *  - pin 6..11 (0x0FC0) LED
       *  - pin 12    (0x1000) R[fbNRESETs

       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void initGPIO(void)
    {
    	*pPORTF_FER   &= ~PF12;	        // |[g F̃vO}uEtO𗘗pł悤ɂB
    	*pPORTFIO_DIR |=  PF12;         // |[gF̕ݒBLEDƃR[fbNRESETo͂
    }


    /** I[fBIER[fbÑZbg
       * 
       * PORT FɊ蓖ĂĂR[fbNEZbgM(PF12)gOB
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */   
    void resetCODEC(void)
    {
        *pPORTFIO_CLEAR = PF12;             // ZbgEsAT[gB
    
        for( int i = 0; i< CODEC_RESET_PULS_WIDTH;i++)	        // AT[gԂ莞ԕێ
            asm volatile( "nop;" );
 	
        *pPORTFIO_SET = PF12;               // ZbgEsfAT[gB


    }

    /** SPORT0̏
       * 
       * I[fBIR[fbNɐڑĂSPORT0BVA
       * tH[}bgI2SŁANbNLRM͊OB̊֐ǂ񂾒iK
       * ł́A|[g̓fBZ[û܂܂ɂĂB
       *
       * ݒ͑MƂȉ̂Ƃ
       * - ONbN
       * - OLRM
       * - I2Sݒ
       *  - xCKFE = 1
       *  - xFSR = 1
       *  - LAxFS = 0
       *  - LxFS = 0
       *  - xRFST = 0
       *  - xDTYPE = 0
       * - 24bit f[^
       * - ZJ_E`l
       * 
       * ڍׂADSP-BF537 Hardware Reference "Stereo Serial Operation" QƂ̂ƁB
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       *
       * ӁFEZ-KIT Lite BF537 Rev 1.0̃[U[SPORT̃NbNуt[
       * MŐݒɕύXȂ΂ȂȂB
       */
    void initSPORT(void)
    {
                // Sport0 Mݒ
    	*pSPORT0_RCR1 = RFSR | RCKFE;
    	*pSPORT0_RCR2 = SPORT0_SLEN_32 | RSFSE;
	
    	        // Sport0 Mݒ
    	*pSPORT0_TCR1 = TFSR | TCKFE;
    	*pSPORT0_TCR2 = SPORT0_SLEN_32 | TSFSE;

	
    }

    /** SPORT DMȀ
       * 
       * SPORT0ɐڑĂDMAݒ肷BDMA3MADMA4MłB
       * I[fBIM16rbgȏ̒̂Ń[hTCY32bit, 
       * AM̂߂ɃI[gobt@A[hgB܂AgvEobt@
       * 邽߂ɁADMA]2ōsA3C̃obt@mۂĊeC
       * ]I邽тɊ荞݂𔭐B
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void initDMA(void)
    {
	
    	        // DMA3̐ݒ
    	*pDMA3_CONFIG = WNR | WDSIZE_32 | DI_EN | DI_SEL | FLOW_AUTO | DMA2D ; // 32bit, 2DDMA, eC荞݁AI[gobt@
    	*pDMA3_START_ADDR = (void *) rxBuffer;                  // MDMAobt@ւ̃|C^
    	*pDMA3_X_COUNT = CH_PER_SAMPLE * SAMPLE_PER_INTR;       // 2DMǍ
    	*pDMA3_X_MODIFY	= sizeof(int);                          // ]Ƃ̃CNg
    	*pDMA3_Y_COUNT = INTR_PER_BUFFER;                       // 2DMA̍s
    	*pDMA3_Y_MODIFY	= sizeof(int);                          // 1s]̃CNg
	
            	// DMA4̐ݒ
    	*pDMA4_CONFIG = WDSIZE_32 | FLOW_AUTO | DMA2D;          // 32bit, 2DDMA, I[gobt@
    	*pDMA4_START_ADDR = (void *)txBuffer;                   // MDMAobt@ւ̃|C^
    	*pDMA4_X_COUNT = CH_PER_SAMPLE * SAMPLE_PER_INTR;       // 2DMǍ
    	*pDMA4_X_MODIFY	= sizeof(int);                          // ]Ƃ̃CNg
    	*pDMA4_Y_COUNT = INTR_PER_BUFFER;                       // 2DMA̍s
    	*pDMA4_Y_MODIFY	= sizeof(int);                          // 1s]̃CNg

    }

    /** 荞݂̃Cl[u
       * 
       * SPORT0 M݂LBSPORT0 M荞݂̓ftHgł
       * DMA3Ɋ蓖ĂĂ̂ŁADMA3݂LɂB
       */
    void initInterrupt(void)
    {

    	        // SPORT0 RX ݂LɁBftHgDMA3
    	*pSIC_IMASK |= IRQ_DMA3;
    }



    void init()
    {
        initGPIO();
        resetCODEC();
        initSPORT();
        initDMA();
        initInterrupt();
        
        initProcessData(SAMPLE_PER_INTR);
    }


    void start(void)
    {
                // DMAJn
    	*pDMA4_CONFIG	|= DMAEN;   // M
    	*pDMA3_CONFIG	|= DMAEN;   // M
	
                // SPORTJn
    	*pSPORT0_TCR1 	|= TSPEN;
    	*pSPORT0_RCR1 	|= RSPEN;
    }


    /** `l̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::rxBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁA`loẴobt@Ɋi[B
     */
        short lchIn[SAMPLE_PER_INTR];
    /** `lo̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::txBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁA afw::processDataԂĂl̍`lf[^
     * ̃obt@ǂݏo afw::txBufferɊi[B
     */
        short lchOut[SAMPLE_PER_INTR];
    /** E`l̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::rxBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁAE`loẴobt@Ɋi[B
     */
        short rchIn[SAMPLE_PER_INTR];
    /** E`lo̓obt@
     *
     * afw::processDataɈƂēn߂̈ꎞobt@B afw::txBuffer̃f[^
     * L,R,L,RɂȂĂ̂ŁA afw::processDataԂĂl̉E`lf[^
     * ̃obt@ǂݏo afw::txBufferɊi[B
     */
        short rchOut[SAMPLE_PER_INTR];
  		
    bool ISR( void )
    {
    	if ( *pSIC_ISR & IRQ_DMA3 ){        // SPORT0_RX݂?
        	static unsigned int bufferIdx = 0;       // gvEobt@pCfbNX
    
        	*pDMA3_IRQ_STATUS = 0x0001;         // ݃NA
	
                    // gvobt@̂ǂ̃obt@g߂
        	if ( *pDMA3_CURR_Y_COUNT == 2 )		// 2DMA̍ŏ̍s̓]Iꍇ
        		bufferIdx = 0;
        	else if ( bufferIdx < 2 )			// ȊȌꍇ
        		bufferIdx ++;
        	else
        	    bufferIdx = 0;                  // lُȏꍇ̏

                	// DMAi[Mf[^̓obt@ɃRs[
                    // Mf[^obt@24bit f[^l߂32bit ϐɊi[Ă̂
                    // 16bitEVtgē̓obt@ɃRs[
        	for( int i =0; i< SAMPLE_PER_INTR; i++ ){
        	    lchIn[i] = rxBuffer[bufferIdx][i][LEFT_CH]  >>16;
        	    rchIn[i] = rxBuffer[bufferIdx][i][RIGHT_CH] >>16;
        	}
		
            	    // [U[ER[obN֐̌Ăяo
        	processData( 
                            (shortfract *)lchIn,       // short^shortfract^
                            (shortfract *)rchIn,      // 傫Ȃ̂ŁA
                            (shortfract *)lchOut,      // LXgɂċϊĂ
                            (shortfract *)rchOut, 
                            SAMPLE_PER_INTR 
                        );

        	        // o̓obt@̃f[^𑗐Mf[^obt@ɃRs[
                    // Mf[^obt@24bit f[^l߂32bit ϐɊi[Ă̂
                    // o̓obt@16bitVtgđMobt@ɃRs[	
            for( int i =0; i< SAMPLE_PER_INTR; i++ ){
        	    txBuffer[bufferIdx][i][LEFT_CH] = lchOut[i] <<16;
        	    txBuffer[bufferIdx][i][RIGHT_CH]= rchOut[i] <<16;
        	}
        	return (true);         // ݏs
    	}
    	else
    	    return(false);          // ݏsȂ

    }

    
};      // namespace afw
	


