/** \file afw.h
 *  \brief t[[N錾t@C
 *  \author AiOEfoCZY
 *  \version 1.0
 *  \date    2006.Sep.8
 *
 * ep[^̐錾t@CBp[^̂Aafw::SAMPLE_PER_INTR̓[U[ύX
 * 悢BC[`afw::initafw::startAudioĂяoăI[fBIJnB
 */
#ifndef  __Talkthrough_DEFINED
	#define __Talkthrough_DEFINED

//--------------------------------------------------------------------------//
// Header files																//
//--------------------------------------------------------------------------//
#include <sys\exception.h>
#include <cdefBF533.h>
#include <ccblkfn.h>
#include <sysreg.h>
/** I[fBIEt[[N
*
* ADSP-BF537 EZ-KIT Liteœ삷I[fBIt[[N֘Å֐ѕϐ܂ޖOԁB
* vO}͈ȉ̊֐ĂŃI[fBIJnB
* - afw::init
* - afw::startAudio
*/
namespace afw
{
//--------------------------------------------------------------------------//
// Symbolic constants														//
//--------------------------------------------------------------------------//
/** TṽXbgB
*
* AD1836Ã}``lE[hł8B[U[ςĂ͂ȂȂB
*/
const int SLOT_PER_SAMPLE = 8;
/** 荞݂P񂠂ɓ]ATvB
*
* [U[ςĂ悢B
*/
const int SAMPLES_PER_INTR = 8;
/** ߋ񕪂̊荞݂̃f[^pӂ邩B
*
* gvobt@Ȃ̂3
*/
const int INTR_PER_BUFFER = 3;

///  addresse for Port B in Flash A Direction Register
//volatile unsigned char * const pFlashA_PortA_Dir =  (unsigned char * )0x20270006;
#define pFlashA_PortA_Dir (volatile unsigned char * )0x20270006

///  addresse for Port B in Flash A Data Register
//volatile unsigned char * const pFlashA_PortA_Data = (unsigned char * )0x20270004;
#define pFlashA_PortA_Data  (volatile unsigned char * )0x20270004


// names for codec registers, used for iCodec1836TxRegs[]
const int DAC_CONTROL_1 = 0x0000;
const int DAC_CONTROL_2 = 0x1000;
const int DAC_VOLUME_0 = 0x2000;
const int DAC_VOLUME_1 = 0x3000;
const int DAC_VOLUME_2 = 0x4000;
const int DAC_VOLUME_3 = 0x5000;
const int DAC_VOLUME_4 = 0x6000;
const int DAC_VOLUME_5 = 0x7000;
const int ADC_0_PEAK_LEVEL = 0x8000;
const int ADC_1_PEAK_LEVEL = 0x9000;
const int ADC_2_PEAK_LEVEL = 0xA000;
const int ADC_3_PEAK_LEVEL = 0xB000;
const int ADC_CONTROL_1 = 0xC000;
const int ADC_CONTROL_2 = 0xD000;
const int ADC_CONTROL_3 = 0xE000;

// names for slots in ad1836 audio frame
const int INTERNAL_ADC_L0 = 0;
const int INTERNAL_ADC_L1 = 1;
const int INTERNAL_ADC_R0 = 4;
const int INTERNAL_ADC_R1 = 5;
const int INTERNAL_DAC_L0 = 0;
const int INTERNAL_DAC_L1 = 1;
const int INTERNAL_DAC_L2 = 2;
const int INTERNAL_DAC_R0 = 4;
const int INTERNAL_DAC_R1 = 5;
const int INTERNAL_DAC_R2 = 6;

/// size of array iCodec1836TxRegs and iCodec1836RxRegs
const int CODEC_1836_REGS_LENGTH = 11;

/// SPI transfer mode
const int TIMOD_DMA_TX = 0x0003;

/// SPORT0 word length
const int SLEN_32 = 0x001f;

/// DMA flow mode
const int FLOW_Autobuffer = 0x1000;

//--------------------------------------------------------------------------//
// Global variables															//
//--------------------------------------------------------------------------//

extern volatile short sCodec1836TxRegs[];
extern volatile int iRxBuffer1[][SAMPLES_PER_INTR][SLOT_PER_SAMPLE];	// 
extern volatile int iTxBuffer1[][SAMPLES_PER_INTR][SLOT_PER_SAMPLE];	// 

//--------------------------------------------------------------------------//
// Prototypes																//
//--------------------------------------------------------------------------//
// in afw.cpp
bool ISR(void);
	
    /** I[fBI̊Jn
       * 
       * ݒ肪ISPORTDMA̗Cl[uAI[fBIJnB
       */

void start(void);
    /** afw̏
       * 
       * I[fBIEt[[N̏B֐͂ЂƂׂ΁Ac̊֐
       * ܂Ƃ߂ČĂłBA afw::start ͌Ă΂Ȃ̂ŁAvO}I
       * Ă΂Ȃ΂ȂȂB
       */
void init(void);

// in processdata.cpp
void initProcessData( int count );
void processData( const short leftIn[], const short rightIn[], short leftOut[], short rightOut[], int count);


} // namespace afw

#endif //__Talkthrough_DEFINED
