//		ADSP-BF533̏[`


#include <cdefBF53x.h>	// WX^EAhX`t@C
#include "utilbf533.h"
#include <ccblkfn.h>
/** \file utilbf533.cpp
 *  \brief BF533 EZKIT [eBeB֐
 *  \author AiOEfoCZY
 *  \version 1.0
 *  \date    2006.Sep.8
 *
 */

/** [eBeB[֐
*
* ADSP-BF533 ŗpł郆[eBeB֐B
*/
	// EZ-KIT BF533֐
namespace utilbf533 {
	/** EZ-KIT Lite̐ݒ
	   * 
	   * ADSP-BF533PLLݒ肵ARAg600MHzɂB
	   * EZ-KIT BF533łCLKINs27MHz^Ă̂ŁA22{
	   * 594HzƂB
	   *
	   * ɔ񓯊oNASDRAMCAŌɃRpjIE`bv
	   */
    void initEzKit(void)
    {
      unsigned int savedIWR;
    								// PLL 
      savedIWR = *pSIC_IWR;
      *pSIC_IWR = 0x1;				// PLL̂݃EFCNAbv
      *pPLL_DIV = 5;				// SCLK̕5 ( 596/6 = 118.8MHz )
      *pPLL_CTL = 22<<9;			// MSEL=22{ ( 27*22 = 594MHz )
      ssync();
      idle();
      *pSIC_IWR = savedIWR;

    								// 񓯊[ݒ (EZ-KIT)
      *pEBIU_AMBCTL0 = 0x7bb07bb0;	
      *pEBIU_AMBCTL1 = 0x7bb07bb0;
      *pEBIU_AMGCTL = 0x000f;		// [oNCl[u	
    //  *pEBIU_AMGCTL = 0x010f;		// [oNCl[u	

      								// SDRAM 
      *pEBIU_SDRRC = 0x00000817;	
      *pEBIU_SDBCTL = 0x00000013;
      *pEBIU_SDGCTL = 0x0091998d;	

    								// FLASH̃|[g
      *pFLASHA_PORTB_OUT = 0x00;	// LEDNA
      *pFLASHA_PORTB_DIR = 0x3f;	// o̓rbg 0-5

      *pFLASHA_PORTA_OUT = 0x00;	// MNA
      *pFLASHA_PORTA_DIR = 0xff;	// o̓rbg 0-7
      ssync();
    }

	
    /** UART֐
    * \param sclk  Hzŕ\SCLKg
    * \param bps  : baud [g
    *
    * UARTݒ肷BSCLKgƊ]baud[g^ƁÂ߂
    * KvȃWX^ݒsBȂA8bit, 1stop bit, non parityłB
    */
    void initUART( unsigned int sclk, unsigned int bps )
    {
    	unsigned int divisor;
	
    	divisor = sclk/(16*bps);				// vZHRUART_DLL/UART_DLHQ
    	*pUART_GCTL = UCEN;						// UART̃NbN
    	ssync();								// GCTLւ̏݊҂
    	*pUART_LCR = DLAB;						// DLL,DLHANZX\ɂ
    	ssync();								// LCRւ̏݊҂
    	*pUART_DLL = divisor & 0x00ff;			// fBoCU[̉8rbgݒ
    	*pUART_DLH = ( divisor >> 8 ) & 0xff;	// fBoCU[̏8rbgݒ
    	ssync();								// DLL, DLHւ݂̏҂
    	*pUART_LCR = WLS(8);					// 8rbgApeBȂA1Xgbvrbg
    	ssync();								// LCRւ݂̏܂ő҂
    }
} // namespace utilbef533
