#include "utilbf537.h"
#include <cdefBF53x.h>

	/** [eBeB֐Q
	   * \file utilbf537.cpp
	   */

namespace utilbf537{
	/** PLL̐ݒ
	   * 
	   * ADSP-BF537PLLݒ肵ARAg600MHzɂB
	   * EZ-KIT BF537łCLKINs25MHz^Ă̂ŁA24{
	   * 600HzƂB
	   */
	void initPLL(void)
	{
	  unsigned int savedIWR;
									// PLL 
	  savedIWR = *pSIC_IWR;
	  *pSIC_IWR = 0x1;				    // PLL̂݃EFCNAbv
	  *pPLL_DIV = 5;				    // SCLK̕5 ( 600/5 = 120MHz )
	  *pPLL_CTL = 24<<9;			    // MSEL=24{ ( 25*24 = 600MHz )
	  asm volatile( "ssync; idle;" );   // PLL̃EFCNAbv҂
	  *pSIC_IWR = savedIWR;
	}

}; // namespace utilbf537

